/******************************************************************************
 *
 *	PalmKart mini
 *	ver 1.3.3
 *	2008.11 / 2009.5
 *	ChoiKyun
 *
 *****************************************************************************/
#include <PalmOS.h>
#include <PalmOSGlue.h>
#include <SonyCLIE.h>
#include "defrsc.h"

//#defien NOMAL
//#define GLOBAL_VALUE_DEFINE
#include "game.h"



/******************************************************************************
 *	vg^Cv
 *****************************************************************************/
Err create_geometry_record( void );
Err create_ghost_record( void );
Err create_coursemap_record( void );
void init_geometry_data_2( PointType (*)[MAP_WIDTH], PointType (*)[MAP_WIDTH] );
void init_geometry_data_3( PointType (*)[MAP_WIDTH], PointType (*)[MAP_WIDTH]  );
void rotate_geometry_tbl( int, PointType (*)[MAP_WIDTH], PointType (*)[MAP_WIDTH] );



/******************************************************************************
 *	O[oȒ萔
 *****************************************************************************/
extern int sin_tbl[];
extern int cos_tbl[];



/************************************************
 *	f[^x[XI[v
 ***********************************************/

// Wϊe[u

Err
open_geometry_db( void )
{
  int i;
  Err err = errNone;
  UInt16 mode = dmModeReadWrite;
  LocalID db_id;
  UInt16 card_no, version;
//  UInt16 attr;
  MemHandle h;
  MemPtr p;
  static Char mes[] = "Creating Geometry DB...";


  // I[v
  Geo.db_p = DmOpenDatabaseByTypeCreator('DATA', appFileCreator, mode );

  // o[W`FbN
  if( Geo.db_p )
    {
      DmOpenDatabaseInfo( Geo.db_p, &db_id, NULL, NULL, &card_no, NULL );
      DmDatabaseInfo( card_no, db_id, NULL, NULL, &version, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL );
      if( version != GEOMETRY_DB_VER )
        {
          DmCloseDatabase( Geo.db_p );
          DmDeleteDatabase( 0, db_id );
          Geo.db_p = NULL;
        }
    }

  // VK쐬
  if( Geo.db_p == NULL )
    {
      // bZ[W
      WinDrawChars(mes, StrLen( mes ), 30, 65 );

      err = DmCreateDatabase( 0, "GeometryDB", appFileCreator, 'DATA', false );
      if( err )
        {
          return err;
        }
      Geo.db_p = DmOpenDatabaseByTypeCreator( 'DATA', appFileCreator, mode );
      if( Geo.db_p == NULL )
        {
          return err;
        }
/*      // obNAbvݒ
      DmOpenDatabaseInfo( Geo.db_p, &db_Id, NULL, NULL, &card_no, NULL );
      DmDatabaseInfo( card_no, db_Id, NULL, &attr, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL );
      attr |= dmHdrAttrBackup;
      DmSetDatabaseInfo( card_no, db_Id, NULL, &attr, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL );
*/
      // o[Wݒ
      version = GEOMETRY_DB_VER;
      DmOpenDatabaseInfo( Geo.db_p, &db_id, NULL, NULL, &card_no, NULL );
      DmSetDatabaseInfo( card_no, db_id, NULL, NULL, &version, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL );

      // f[^쐬
      err = create_geometry_record();
      if( err )
        {
          DmCloseDatabase( Geo.db_p );
          return err;
        }
    }

  // R[h̃|C^擾
  for( i = 0; i< REC_MAX; i++ )
    {
      h = DmQueryRecord( Geo.db_p, i );
      err = DmGetLastErr();
      if ( err )
        {
          DmCloseDatabase( Geo.db_p );
          return err;
        }

      Geo.save_h[i] = h;

      p = MemHandleLock( h );
      Geo.table_p[i] = (PointType *) p;
    }

  return err;
}



// S[Xg

Err
open_ghost_db( void )
{
  Err err = errNone;
  UInt16 mode = dmModeReadWrite;
  LocalID db_id;
  UInt16 card_no, version;
//  UInt16 attr;
  MemHandle h;
  MemPtr p;
  int i;
  static Char mes[] = "Creating Ghost DB...";


  // I[v
  Ghost.db_p = DmOpenDatabaseByTypeCreator('GHST', appFileCreator, mode );

  // o[W`FbN
  if( Ghost.db_p )
    {
      DmOpenDatabaseInfo( Ghost.db_p, &db_id, NULL, NULL, &card_no, NULL );
      DmDatabaseInfo( card_no, db_id, NULL, NULL, &version, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL );
      if( version != GHOST_DB_VER )
        {
          DmCloseDatabase( Ghost.db_p );
          DmDeleteDatabase( 0, db_id );
          Ghost.db_p = NULL;
        }
    }

  // VK쐬
  if( Ghost.db_p == NULL )
    {
      // bZ[W
      WinDrawChars(mes, StrLen( mes ), 30, 75 );

      err = DmCreateDatabase( 0, "GhostDB", appFileCreator, 'GHST', false );
      if( err )
        {
          return err;
        }
      Ghost.db_p = DmOpenDatabaseByTypeCreator( 'GHST', appFileCreator, mode );
      if( Ghost.db_p == NULL )
        {
          return err;
        }
/*      // obNAbvݒ
      DmOpenDatabaseInfo( Geo.db_p, &db_Id, NULL, NULL, &card_no, NULL );
      DmDatabaseInfo( card_no, db_Id, NULL, &attr, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL );
      attr |= dmHdrAttrBackup;
      DmSetDatabaseInfo( card_no, db_Id, NULL, &attr, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL );
*/

      // o[Wݒ
      version = GHOST_DB_VER;
      DmOpenDatabaseInfo( Ghost.db_p, &db_id, NULL, NULL, &card_no, NULL );
      DmSetDatabaseInfo( card_no, db_id, NULL, NULL, &version, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL );

      // f[^쐬
      err = create_ghost_record();
      if( err )
        {
          DmCloseDatabase( Ghost.db_p );
          return err;
        }
    }

  // R[h̃|C^擾
  for( i = 0; i < COURSE_MAX; i++ )
    {
      h = DmGetRecord( Ghost.db_p, i );
      err = DmGetLastErr();
      if ( err )
        {
          DmCloseDatabase( Ghost.db_p );
          return err;
        }

      Ghost.read_h[i] = h;

      p = MemHandleLock( h );
      Ghost.read_p[i] = (GhostRecType *) p;
    }
  return err;
}


// R[X}bv
Err
open_coursemap_db( void )
{
  Err err = errNone;
  UInt16 mode = dmModeReadWrite;
  LocalID db_id;
  UInt16 card_no, version;
//  UInt16 attr;
  MemHandle h;
  MemPtr p;
  static Char mes[] = "Creating CourseMap DB...";


  // I[v
  CourseMap.db_p = DmOpenDatabaseByTypeCreator('CMAP', appFileCreator, mode );

  // o[W`FbN
  if( CourseMap.db_p )
    {
      DmOpenDatabaseInfo( CourseMap.db_p, &db_id, NULL, NULL, &card_no, NULL );
      DmDatabaseInfo( card_no, db_id, NULL, NULL, &version, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL );
      if( version != COURSEMAP_DB_VER )
        {
          DmCloseDatabase( CourseMap.db_p );
          DmDeleteDatabase( 0, db_id );
          CourseMap.db_p = NULL;
        }
    }

  // VK쐬
  if( CourseMap.db_p == NULL )
    {
      // bZ[W
      WinDrawChars(mes, StrLen( mes ), 30, 85 );

      err = DmCreateDatabase( 0, "CourseMapDB", appFileCreator, 'CMAP', false );
      if( err )
        {
          return err;
        }
      CourseMap.db_p = DmOpenDatabaseByTypeCreator( 'CMAP', appFileCreator, mode );
      if( CourseMap.db_p == NULL )
        {
          return err;
        }
/*      // obNAbvݒ
      DmOpenDatabaseInfo( Geo.db_p, &db_Id, NULL, NULL, &card_no, NULL );
      DmDatabaseInfo( card_no, db_Id, NULL, &attr, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL );
      attr |= dmHdrAttrBackup;
      DmSetDatabaseInfo( card_no, db_Id, NULL, &attr, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL );
*/

      // o[Wݒ
      version = COURSEMAP_DB_VER;
      DmOpenDatabaseInfo( CourseMap.db_p, &db_id, NULL, NULL, &card_no, NULL );
      DmSetDatabaseInfo( card_no, db_id, NULL, NULL, &version, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL );

      // f[^쐬
      err = create_coursemap_record();
      if( err )
        {
          DmCloseDatabase( CourseMap.db_p );
          return err;
        }
    }

  // R[h̃|C^擾
  h = DmGetRecord( CourseMap.db_p, 0 );
  err = DmGetLastErr();
  if ( err )
    {
      DmCloseDatabase( CourseMap.db_p );
      return err;
    }

  CourseMap.read_h = h;

  p = MemHandleLock( h );
  CourseMap.read_p = (int *) p;

  return err;
}



/************************************************
 *	f[^x[XN[Y
 ***********************************************/

// Wϊe[u

void
close_geometry_db( void )
{
  int i;


  for( i = 0; i < REC_MAX; i++ )
    {
      MemHandleUnlock( Geo.save_h[i] );
    }

  DmCloseDatabase( Geo.db_p );
}



// S[Xg

void close_ghost_db( void )
{
  int i;


  for( i = 0; i < COURSE_MAX; i++ )
    {
      MemHandleUnlock( Ghost.read_h[i] );
      DmReleaseRecord( Ghost.db_p, i, true );
    }

  DmCloseDatabase( Ghost.db_p );
}


// R[X}bv
void close_coursemap_db( void )
{
  MemHandleUnlock( CourseMap.read_h );
  DmReleaseRecord( CourseMap.db_p, 0, true );

  DmCloseDatabase( CourseMap.db_p );
}



/************************************************
 *	S[XgR[hXV
 ***********************************************/
Err write_ghost_record( void )
{
  Err err = errNone;


  err = DmWrite( Ghost.read_p[ Course.no ], 0, Ghost.work_p, REC_GHOST_SIZE );
  if( err )
    {
      return err;
    }
  return err;
}



/************************************************
 *	S[Xgf[^x[X폜
 ***********************************************/
void delete_ghost_db( void )
{
  DmDeleteDatabase( 0, DmFindDatabase( 0, "GhostDB" ) );
}



/************************************************
 *	WϊR[h쐬
 *	80*32hbg 128 / 2
 *	64R[h
 ***********************************************/
static Err
create_geometry_record( void )
{
  int i, rad;
  Err err = errNone;
  MemHandle h;
  MemPtr p;
  PointType (*dst_p)[MAP_WIDTH], (*src_p)[MAP_WIDTH];


  // HO@px 0rad
  src_p = (PointType (*)[ MAP_WIDTH ]) MemPtrNew( sizeof(PointType) * MAP_WIDTH * MAP_HEIGHT );
  ErrFatalDisplayIf( !src_p, "Error Allocating Buffer" );
  // Hp
  dst_p = (PointType (*)[ MAP_WIDTH ]) MemPtrNew( sizeof(PointType) * MAP_WIDTH * MAP_HEIGHT );
  ErrFatalDisplayIf( !dst_p, "Error Allocating Buffer" );


  rad = 0;
  // W
  init_geometry_data_3( dst_p, src_p );

  for( i = 0; i < REC_MAX; i++ )
    {
      h = DmNewRecord( Geo.db_p, (UInt16 *)&i, REC_SIZE );
      p = MemHandleLock( h );

      err = DmWrite( p, 0, dst_p, REC_SIZE );
      if( err )
        {
          MemHandleUnlock( h );
          DmReleaseRecord( Geo.db_p, i, true );
          MemPtrFree( src_p );
          MemPtrFree( dst_p );
          return err;
        }

      MemHandleUnlock( h );
      DmReleaseRecord( Geo.db_p, i, true );

      rotate_geometry_tbl( rad, dst_p, src_p );
      rad++;
    }

  MemPtrFree( src_p );
  MemPtrFree( dst_p );

  return err;
}



/************************************************
 *	S[XgR[h쐬
 ***********************************************/
static Err
create_ghost_record( void )
{
  int i;
  Err err = errNone;
  MemHandle h;
  MemPtr p;


  for( i = 0; i < COURSE_MAX; i++ )
    {
      h = DmNewRecord( Ghost.db_p, (UInt16 *)&i, REC_GHOST_SIZE );
      p = MemHandleLock( h );

      err = DmSet( p, 0, REC_GHOST_SIZE, -1 ); //  (-1)
      if( err )
        {
          MemHandleUnlock( h );
          DmReleaseRecord( Ghost.db_p, i, true );
          return err;
        }

      MemHandleUnlock( h );
      DmReleaseRecord( Ghost.db_p, i, true );
    }
  return err;
}



/************************************************
 *	R[X}bvR[h쐬
 ***********************************************/
static Err
create_coursemap_record( void )
{
  int i, j, w;
  UInt16 index = 0;
  Err err = errNone;
  MemHandle h;
  MemPtr p;
  int *work_p, *map_p, *write_p;
  double rate = 0.7;


  // R[X}bvWQƃobt@
  work_p = (int *)MemPtrNew( sizeof(int) * COURSE_MAP_W * COURSE_MAP_H );
  ErrFatalDisplayIf( !work_p, "Error Allocating Buffer" );

  // f[^쐬
  map_p = work_p;
  write_p = work_p;

  for( i = 0; i < COURSE_MAP_W * COURSE_MAP_H; i++ )
    {
      *write_p++ = -1;
    }

  for( i = 0; i < COURSE_MAP_H; i++ )
    {
      w = COURSE_MAP_W * rate + 0.5;
      write_p = map_p + (BACK_WIDTH / 2 - w / 2);
      for( j = 0; j < w; j++ )
        {
          *write_p++ = (int) ( (double) (COURSE_MAP_W / (double) w) * j * COURSE_MAP_W_ASPECT + 0.5);
        }
      map_p += BACK_WIDTH;
      rate += 0.005;
    }

  // R[h
  h = DmNewRecord( CourseMap.db_p, &index, sizeof(int) * COURSE_MAP_W * COURSE_MAP_H );
  p = MemHandleLock( h );

  err = DmWrite( p, 0, work_p, sizeof(int) * COURSE_MAP_W * COURSE_MAP_H );
  if( err )
    {
      MemHandleUnlock( h );
      DmReleaseRecord( CourseMap.db_p, i, true );
      MemPtrFree( work_p );
      return err;
    }

  MemHandleUnlock( h );
  DmReleaseRecord( CourseMap.db_p, 0, true );

  MemPtrFree( work_p );

  return err;
}



#if 0
/************************************************
 *	Wϊe[ȕ 2d
 ***********************************************/
static void
init_geometry_data_2( PointType (*dst_p)[MAP_WIDTH], PointType (*src_p)[MAP_WIDTH] )
{
  int i, j;


  for( i = 0; i < MAP_HEIGHT; i++ )
    {
      for( j = 0; j < MAP_WIDTH; j++ )
        {
          src_p[i][j].x = j;
          src_p[i][j].y = i;
        }
    }

  MemMove( dst_p, src_p, REC_SIZE );
}
#endif



/************************************************
 *	Wϊe[ȕ 3d
 ***********************************************/
static void
init_geometry_data_3( PointType (*dst_p)[MAP_WIDTH], PointType (*src_p)[MAP_WIDTH] )
{
  int i, j;
  double xx, x, yy, y, s;


  x = -(MAP_WIDTH / 2); y = MAP_HEIGHT;
  s = 0.1;

  for( i = 0; i < MAP_HEIGHT; i++ )
    {
      for( j = 0; j < MAP_WIDTH; j++ )
        {
          xx = x / (s *2.5);
          if( xx > 0 )
            xx += 0.5;
          else if( xx < 0 )
            xx -= 0.5;
          src_p[i][j].x = (int) xx;

          yy = MAP_HEIGHT - y / s;
          if( yy > 0 )
            yy += 0.5;
          else if( yy < 0 )
            yy -= 0.5;

          src_p[i][j].y = (int) yy;
          x++;
        }
      x = -(MAP_WIDTH / 2); y--;
      s += 0.0346;
    }

  MemMove( dst_p, src_p, REC_SIZE );
}



/************************************************
 *	Wϊe[ủ]
 ***********************************************/
static void
rotate_geometry_tbl( int r, PointType (*dst_p)[MAP_WIDTH], PointType (*src_p)[MAP_WIDTH] )
{
  int i, j, src_rad;
  Coord dst_x, dst_y;
  Int32 cx, cy, src_x, src_y, src_sin, src_cos;


  cx = ROTATE_CENTER_X; cy = ROTATE_CENTER_Y; // S

//  src_rad =  -r  & RAD_MAX; // v
  src_rad = r & RAD_MAX; // v

  src_cos = cos_tbl[ src_rad ];
  src_sin = sin_tbl[ src_rad ];

  for( i = 0; i < MAP_HEIGHT; i++ )
    {
      for( j = 0; j < MAP_WIDTH; j++ )
        {
          src_x = src_p[i][j].x;
          src_y = src_p[i][j].y;
          // ]
          dst_x = ( (src_x - cx) * src_cos - (src_y - cy) * src_sin ) / 1024 + cx;
          dst_y = ( (src_x - cx) * src_sin + (src_y - cy) * src_cos ) / 1024 + cy;

          dst_p[i][j].x = dst_x;
          dst_p[i][j].y = dst_y;
        }
    }
}



