/******************************************************************************
 *
 *	PalmKart mini
 *	ver 1.3.3
 *	2008.11 / 2009.5
 *	ChoiKyun
 *
 *****************************************************************************/
#include <PalmOS.h>
#include <PalmOSGlue.h>
#include <SonyCLIE.h>
#include "defrsc.h"

//#define GLOBAL_VALUE_DEFINE
#include "game.h"



/******************************************************************************
 *	vg^Cv
 *****************************************************************************/
void show_ready( void );
void show_over( void );
void show_clear( void  );
void show_pause( void );
void show_title( void );
void show_bomb( void );



/******************************************************************************
 *	O[oȒ萔
 *****************************************************************************/



/************************************************
 *	Q[Cxg
 ***********************************************/
Boolean
select_game_event( void )
{
  Boolean result = false;
  UInt32 key, keyf;


  switch( Game.state )
    {
    case GAME_TITLE:
      select_course();

      if( Key.keep & (Keyset.acc | Keyset.brake | Keyset.center) )
        {
          init_game();
          Game.state = GAME_READY;
          //set_se( click );
        }
      result = true;
      break;

    case GAME_READY:
      pre_start();

      result = true;
      break;

    case GAME_FINISH:
      Game.state = GAME_RESULT;

      result = true;
      break;

    case GAME_RESULT:
      disp_total_record();

      if( input_anykey() && Rec_wait.lap6 < 0 )
        {
          key = Key.single; keyf = Key.keep;
          if( Engine.cc == MODE_100CC )
            check_hiscore( Lap.total );

          Key.single = key; Key.keep = keyf;
          Game.state = GAME_TITLE;

          show_title();
        }
      result = true;
      break;

    case GAME_OVER:
      draw_bg();
      draw_3d_view();
      if( Owata.smoke_wait >= 6 )
        draw_kart();
      show_bomb();

      if( input_anykey() )
        {
          Game.state = GAME_TITLE;
          show_title();
        }
      result = true;
      break;
    }

  return result;
}



/************************************************
 *	^Cg\
 ***********************************************/
void
show_title( void )
{
//  clear_status();
  sprite( 0, 0, BMP_TITLE );
}



/************************************************
 *	Xe[^Xʕ\
 ***********************************************/
void
show_status( void )
{
  // bv
  sprite( 0, 2, BMP_LAP );
  // ^C
  sprite( 40, 2, BMP_TIME );
  // '
  sprite( 89, 2, BMP_SEP1 );
  // ''
  sprite( 111, 2, BMP_SEP2 );
  // 0
  show_num( 126, 2, 0, 1 );
}



/************************************************
 *	ʉACR\
 ***********************************************/
void
disp_se( void )
{
  // ʉACR
  sprite( 159-16, 2, Sound.on + BMP_BGM_SE );
}



/************************************************
 *	͑҂
 ***********************************************/
Boolean
input_anykey( void )
{
  if( Key.keep & ( Keyset.acc | Keyset.brake | Keyset.center)
      || Pen.down )
    {
      Pen.down = false;
//      set_se( click );

      return true;
    }

  return false;
}



///////////////////////////////////////////////////////////////////////////////

/************************************************
 *	Ĥނ
 ***********************************************/
static void
show_bomb( void )
{
  if( --Owata.bomb_wait > SEC )
    {
//      sprite( SHIP_X, SHIP_Y, Bmp.handle[ BMP_BOMB ] );
    }
  else
    {
      show_over();
    }

  if( Owata.smoke )
    {
      Owata.smoke_wait--;
      if( Owata.smoke_wait < 6 && Owata.smoke_wait > 0 )
        {
          sprite( SHIP_X-4, SHIP_Y-4, BMP_BOMB );
          set_se( rough );
        }
    }
}



/************************************************
 *	Q[I[o[\
 ***********************************************/
static void
show_over( void )
{
  if( Owata.over_y < 35 )
    Owata.over_y += 2;
  sprite( 0, Owata.over_y, BMP_OVER );

  if( Owata.over_y > 35 )
    {
      Owata.smoke = true;
    }
}



/************************************************
 *	|[Y\
 ***********************************************/
static void
show_pause( void )
{
}



