/******************************************************************************
 *
 *	PalmKart mini
 *	ver 1.3.3
 *	2008.11 / 2009.5
 *	ChoiKyun
 *
 *****************************************************************************/
#include <PalmOS.h>
#include <PalmOSGlue.h>
#include <SonyCLIE.h>
#include "defrsc.h"

//#define GLOBAL_VALUE_DEFINE
#include "game.h"



/******************************************************************************
 *	vg^Cv
 *****************************************************************************/
void init_hiscore( void );			// nCXRA
void input_name( void );			// O
Boolean score_ranking_handler( EventPtr );	// nh
Boolean score_name_handler( EventPtr );   	// nh
void clear_hiscore( void );			// LONA
void print_ranking( void );



/************************************************
 *	l\
 ***********************************************/
void
show_num( Coord x, Coord y, UInt16 num, int d )
{
  int i, pos = (d-1) << 3; //* (NUM_WIDTH+1);


  for( i = 0; i < d; i++ )
    {
      sprite_num( x+pos, y, (num % 10) << 3 );//* 8 );
      num /=10;
      pos -= (NUM_WIDTH+1);
    }
}



/************************************************
 *	nCXRAF
 ***********************************************/
void
init_hiscore( void )
{
  int i;


  for( i = 0; i < MAX_RANKING; i++ )
    {
      StrCopy( Rank.ranking[i].name, "------" );
      Rank.ranking[i].time = 0;
    }

  StrCopy( Rank.last_name, "------" );
  Rank.course = -1;
  Rank.page = 0;
}



/************************************************
 *	nCXRAFǉ
 ***********************************************/
void
check_hiscore( UInt32 time )
{
  int pos = Course.no;


  // nCXRÃ`FbN
  if( Rank.ranking[ pos ].time != 0 && Rank.ranking[ pos ].time <= time ) return;

  // O̓
  input_name();
  StrCopy( Rank.ranking[ pos ].name, Rank.last_name );
  // nCXRAXV
  Rank.ranking[ pos ].time = time;
  Rank.course = pos;

  // S[Xgf[^XV
  if( write_ghost_record() )
    {
      // G[
      FrmAlert( GhostDBErrorAlert );
      close_ghost_db();
      // S[Xgf[^x[X폜
      delete_ghost_db();
    }

  // XRALO\
  show_ranking();
}



/************************************************
 *	XRALO\
 ***********************************************/
void
show_ranking( void )
{
  FormPtr save_form_p,form_p;
  UInt16 index;
  UInt32 old_key;


  // ݂̃tH[̕ۑ
  save_form_p = FrmGetActiveForm();

  // LOtH[
  form_p = FrmInitForm( Rank_bordForm );
  FrmSetActiveForm( form_p );
  FrmDrawForm( form_p );

  Rank.page = Course.no / 5;

  //vbV{^
  if( Rank.page == 0 )
    index = FrmGetObjectIndex( form_p, rank_bord1PushButton );
  else
    index = FrmGetObjectIndex( form_p, rank_bord2PushButton );
  FrmSetControlValue( form_p, index, 1 );

  // nhݒ
  FrmSetEventHandler( form_p, score_ranking_handler );

  print_ranking();

  // n[hL[}XNi}uj
  old_key = KeySetMask( ~(UInt32)(keyBitPageUp
                                  | keyBitPageDown
                                  | keyBitHard1
                                  | keyBitHard2
                                  | keyBitHard3
                                  | keyBitHard4) );
  FrmDoDialog( form_p );
  KeySetMask( old_key );

  FrmDeleteForm( form_p );
  FrmSetActiveForm( save_form_p );
}



///////////////////////////////////////////////////////////////////////////////

/************************************************
 *	nCXRAFO
 ***********************************************/
static void
input_name( void )
{
  FormPtr save_form_p,input_p;
  MemHandle name_h;
  char *name_p;
  UInt16 index, button;
  UInt32 old;


  // ݂̃tH[Ҕ
  save_form_p = FrmGetActiveForm();

  // tH[
  input_p = FrmInitForm( Input_nameForm );
  // tB[hINDEX
  index = FrmGetObjectIndex( input_p, input_nameFieldField );
  // tH[JX
  FrmSetFocus( input_p, index );
  // KtBeBXe[g
  GrfSetState( false, false, true );

  // n[hL[}XNi}uj
  old = KeySetMask( ~(UInt32)(keyBitPageUp
                              | keyBitPageDown
                              | keyBitHard1
                              | keyBitHard2
                              | keyBitHard3
                              | keyBitHard4) );

  Key.first_center = true; // Z^[L[dh~
  // nhݒ
  FrmSetEventHandler( input_p, score_name_handler );
  // O̓_CAO\
  button = FrmDoDialog( input_p );
  KeySetMask( old );

  // nh擾
  name_h = FldGetTextHandle( FrmGetObjectPtr( input_p, index) );
  // nh؂藣
  FldSetTextHandle( FrmGetObjectPtr( input_p, index ), 0 );
  // _CAO폜
  FrmDeleteForm( input_p );
  FrmSetActiveForm( save_form_p );

  if( name_h != NULL )
    {
      name_p = MemHandleLock( name_h ); // |C^擾
      if( name_p[0] != '\0' && button == input_nameOkButton )
        {
          // ÕRs[
          StrCopy( Rank.last_name, name_p );
        }
      MemHandleFree( name_h ); // nh
    }
}



/************************************************
 *	XRALÕnh
 ***********************************************/
static Boolean
score_ranking_handler( EventPtr event_p )
{
  if( event_p ->eType == ctlSelectEvent )
    {
      if( event_p ->data.ctlSelect.controlID == rank_bordClearButton )
        {
          // A[g\
          if( FrmAlert( Clear_rankingAlert ) == Clear_rankingYes )
            clear_hiscore();

          return true;
        }
      else if( event_p -> data.ctlSelect.controlID == rank_bord1PushButton )
        {
          Rank.page = 0;
          print_ranking();
        }
      else if( event_p -> data.ctlSelect.controlID == rank_bord2PushButton )
        {
          Rank.page = 1;
          print_ranking();
        }
    }
  
  return false;
}



/************************************************
 *	O͂̂̃nh
 ***********************************************/
static Boolean
score_name_handler( EventPtr event_p )
{
  Boolean handled = false;
  UInt32 key;

  key = KeyCurrentState();
  if( key & ( KEY_1|KEY_2|KEY_3|KEY_4
              |keyBitRockerLeft|keyBitRockerRight|keyBitRockerUp|keyBitRockerDown ) )
    Key.first_center = false;

  if( event_p ->eType == keyDownEvent )
    {
      if( TxtGlueCharIsVirtual( event_p ->data.keyDown.modifiers,
                                event_p ->data.keyDown.chr) )
        {
          switch( event_p ->data.keyDown.chr )
            {
            case vchrHard1: // n[hL[}XN@ꂵ
            case vchrHard2:
            case vchrHard3:
            case vchrHard4:
            case vchrPageDown:
            case vchrPageUp:
              handled = true;
              break;

            case vchrRockerCenter: // Z^[L[dɂȂ̂h~
              if( Key.first_center )
                {
                  Key.first_center = false;
                  handled = true;
                }
            }
        }
    }

  return handled;
}



/************************************************
 *	nCXRANA
 ***********************************************/
static void
clear_hiscore( void )
{
  Err err = errNone;
  int i;


  for( i = 0; i < MAX_RANKING; i++ )
    {
      StrCopy( Rank.ranking[i].name, "------");
      Rank.ranking[i].time = 0;
      Rank.course = -1;
    }

  print_ranking();

  for( i = 0; i < MAX_RANKING; i++ )
    {
      err = DmSet( Ghost.read_p[i], 0, REC_GHOST_SIZE, -1 ); //  (-1)
      if( err )
        {
          // G[
          FrmAlert( GhostDBErrorAlert );
          close_ghost_db();
          // S[Xgf[^x[X폜
          delete_ghost_db();
          return;
        }
    }
}



/************************************************
 *	LO\
 ***********************************************/
static void
print_ranking( void )
{
  RectangleType r;
  Coord y;
  int i;
  char score_string[2+1];
  UInt32 time;
  IndexedColorType col;


  WinPushDrawState();
  FntSetFont( largeBoldFont );

  // LO`
  for( i = 0; i < MAX_PAGE_RANKING; i++ )
    {
      if( Rank.course == (i + Rank.page * 5) )
        col = INDEX_RED;
      else
        col = INDEX_BLACK;

      WinSetTextColor( col );

      y = i * 24 + 24;
      r.topLeft.x = 20; r.topLeft.y = y; r.extent.x = 152; r.extent.y = 12;
      WinEraseRectangle( &r, 0 );

      // O
      WinDrawChars( Rank.ranking[i + Rank.page * 5].name,
                    StrLen( Rank.ranking[i + Rank.page * 5].name ),
                    24,
                    y );

      time = Rank.ranking[i + Rank.page * 5].time;
      if( time )
        {
          WinDrawChars( "0", 1, 135, y );
          StrIToA( score_string, time % 10 );
          WinDrawChars( score_string,
                        StrLen( score_string ),
                        135 - FntCharsWidth( score_string, StrLen( score_string ) ),
                        y );

          WinDrawChars( "\"", 1, 120, y );
          time /= 10;

          StrIToA( score_string, time % 60 );
          WinDrawChars( score_string,
                        StrLen( score_string ),
                        120 - FntCharsWidth( score_string, StrLen( score_string ) ),
                        y );

          WinDrawChars( "'", 1, 100, y );
          time /= 60;

          StrIToA( score_string, time % 60 );
          WinDrawChars( score_string,
                        StrLen( score_string ),
                        100 - FntCharsWidth( score_string, StrLen( score_string ) ),
                        y );
        }
      else
        {
          WinPushDrawState();
          col = INDEX_GRAY;
          WinSetTextColor( col );
          WinDrawChars( "no entry", 8, 95, y );
          WinPopDrawState();
        }
    }

  WinPopDrawState();
}



